Bug 1055395 - Review Request: ocaml-xmlm - A streaming XML codec
Summary: Review Request: ocaml-xmlm - A streaming XML codec
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1055398
TreeView+ depends on / blocked
 
Reported: 2014-01-20 07:32 UTC by Michel Alexandre Salim
Modified: 2014-02-24 12:30 UTC (History)
3 users (show)

Fixed In Version: ocaml-xmlm-1.2.0-3.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-02-24 12:27:15 UTC
Type: ---
loganjerry: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)
Build with -g (300 bytes, patch)
2014-02-13 17:39 UTC, Ville Skyttä
no flags Details | Diff

Description Michel Alexandre Salim 2014-01-20 07:32:14 UTC
Spec URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-xmlm.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-xmlm-1.2.0-1.fc20.src.rpm
Description:
Xmlm is an OCaml streaming codec to decode and encode the XML data
format. It can process XML documents without a complete in-memory
representation of the data.
Fedora Account System Username: salimma

Comment 1 Jerry James 2014-02-07 18:45:40 UTC
I will take this review.

Comment 2 Jerry James 2014-02-07 19:58:21 UTC
The first eight issues are repeats from the previous reviews:

1) Remove the internal dependency generator workarounds.

2) Build a usable -debuginfo package on platforms that generate binary code.

3) The build requires ocaml-findlib only, not ocaml-findlib-devel.

4) Add ExclusiveArch: %{ocaml_arches} to the spec file.

5) Add %{?_isa} to the -devel dependency on the main package.

6) Remove rm -rf $RPM_BUILD_ROOT from the top of %install.

7) Move %define libname down farther and make it %global instead.

8) Consider adding a %check script; perhaps include a small XML file in the
   sources and use xmltrip to convert it to something.  The idea would be to
   just show that it runs at all, rather than segfaulting, producing no
   output, etc.

9) Shouldn't the first line of %build be something like this?

   ./pkg/build %(sed 's/0/false;s/1/true' <<< %{opt})

10) The spec BRs ocaml-ocamldoc, but then doesn't use it.  Plus the prebuilt
    documentation in the doc subdirectory doesn't go into either binary RPM.
    Either regenerate the documentation with ocaml-ocamldoc, or drop the BR.
    In either case, the documentation should probably go into the -devel RPM.

11) Speaking of documentation, I think that README.md would fit better in the
    main package than in -devel.  It gives a succint description of what the
    package does, and describes the xmltrip binary.  It also mentions the
    license, which is good in the absence of a separate license file.

12) Permissions on xmltrip and the binary are 775, but should be 755.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
[-]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[!]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ocaml:
[x]: This should never happen

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ocaml-xmlm-
     devel
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define libname %(echo %{name} |
     sed -e 's/^ocaml-//')
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ocaml-xmlm-1.2.0-1.fc21.x86_64.rpm
          ocaml-xmlm-devel-1.2.0-1.fc21.x86_64.rpm
          ocaml-xmlm-1.2.0-1.fc21.src.rpm
ocaml-xmlm.x86_64: W: spelling-error Summary(en_US) codec -> codex, code, codes
ocaml-xmlm.x86_64: W: spelling-error %description -l en_US codec -> codex, code, codes
ocaml-xmlm.x86_64: W: no-documentation
ocaml-xmlm.x86_64: E: non-standard-executable-perm /usr/bin/xmltrip 0775L
ocaml-xmlm.x86_64: E: non-standard-executable-perm /usr/lib64/ocaml/xmlm/xmlm.cmxs 0775L
ocaml-xmlm.x86_64: W: no-manual-page-for-binary xmltrip
ocaml-xmlm.src: W: spelling-error Summary(en_US) codec -> codex, code, codes
ocaml-xmlm.src: W: spelling-error %description -l en_US codec -> codex, code, codes
3 packages and 0 specfiles checked; 2 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ocaml-xmlm-devel ocaml-xmlm
ocaml-xmlm.x86_64: W: spelling-error Summary(en_US) codec -> codex, code, codes
ocaml-xmlm.x86_64: W: spelling-error %description -l en_US codec -> codex, code, codes
ocaml-xmlm.x86_64: W: no-documentation
ocaml-xmlm.x86_64: E: non-standard-executable-perm /usr/bin/xmltrip 0775L
ocaml-xmlm.x86_64: E: non-standard-executable-perm /usr/lib64/ocaml/xmlm/xmlm.cmxs 0775L
ocaml-xmlm.x86_64: W: no-manual-page-for-binary xmltrip
2 packages and 0 specfiles checked; 2 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
ocaml-xmlm-devel (rpmlib, GLIBC filtered):
    ocaml-xmlm

ocaml-xmlm (rpmlib, GLIBC filtered):
    ocaml(Array)
    ocaml(Buffer)
    ocaml(Char)
    ocaml(Hashtbl)
    ocaml(List)
    ocaml(Pervasives)
    ocaml(String)
    ocaml(runtime)



Provides
--------
ocaml-xmlm-devel:
    ocaml-xmlm-devel
    ocaml-xmlm-devel(x86-64)

ocaml-xmlm:
    ocaml(Xmlm)
    ocaml-xmlm
    ocaml-xmlm(x86-64)



Source checksums
----------------
http://erratique.ch/software/xmlm/releases/xmlm-1.2.0.tbz :
  CHECKSUM(SHA256) this package     : d012018af5d1948f65404e1cc811ae0eab563b23006416f79b6ffc627966dccb
  CHECKSUM(SHA256) upstream package : d012018af5d1948f65404e1cc811ae0eab563b23006416f79b6ffc627966dccb


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1055395 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Ocaml, C/C++
Disabled plugins: Java, Python, SugarActivity, fonts, Haskell, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Michel Alexandre Salim 2014-02-08 03:13:30 UTC
Thanks for the review -- feedback incorporated in -2:

Spec URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-xmlm.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-xmlm-1.2.0-2.fc20.src.rpm

Comment 4 Jerry James 2014-02-10 18:18:14 UTC
OK, that fixes all of the issues.  This package is APPROVED.

Comment 5 Michel Alexandre Salim 2014-02-11 04:20:06 UTC
Thanks for the review!

New Package SCM Request
=======================
Package Name: ocaml-xmlm
Short Description: A streaming XML codec
Owners: salimma
Branches: f19 f20
InitialCC:

Comment 6 Gwyn Ciesla 2014-02-11 13:12:35 UTC
Git done (by process-git-requests).

Comment 7 Fedora Update System 2014-02-12 01:19:22 UTC
ocaml-xmlm-1.2.0-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ocaml-xmlm-1.2.0-2.fc19

Comment 8 Fedora Update System 2014-02-12 01:19:31 UTC
ocaml-xmlm-1.2.0-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ocaml-xmlm-1.2.0-2.fc20

Comment 9 Fedora Update System 2014-02-12 14:43:31 UTC
ocaml-xmlm-1.2.0-2.fc20 has been pushed to the Fedora 20 testing repository.

Comment 10 Ville Skyttä 2014-02-13 17:39:00 UTC
Created attachment 862933 [details]
Build with -g

(In reply to Jerry James from comment #2)
> 2) Build a usable -debuginfo package on platforms that generate binary code.

This doesn't seem to have happened, -debuginfo doesn't include sources. The attached patch fixes that but the rest of $RPM_OPT_FLAGS aren't being used; I don't know enough about ocaml to tell whether/how that should be fixed.

Comment 11 Michel Alexandre Salim 2014-02-13 18:10:53 UTC
(In reply to Ville Skyttä from comment #10)
> Created attachment 862933 [details]
> Build with -g
> 
> (In reply to Jerry James from comment #2)
> > 2) Build a usable -debuginfo package on platforms that generate binary code.
> 
> This doesn't seem to have happened, -debuginfo doesn't include sources. The
> attached patch fixes that but the rest of $RPM_OPT_FLAGS aren't being used;
> I don't know enough about ocaml to tell whether/how that should be fixed.

Thanks; will push a revision once I investigate the optflags issue

Comment 12 Fedora Update System 2014-02-24 12:27:15 UTC
ocaml-xmlm-1.2.0-3.fc20 has been pushed to the Fedora 20 stable repository.

Comment 13 Fedora Update System 2014-02-24 12:30:28 UTC
ocaml-xmlm-1.2.0-3.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.